package silmar.contexts.gameplay.entities.beings.monsters.specializations

import silmar.contexts.gameplay.entities.beings.monsters.types.SilmarMonsterTypes
import silmarengine.contexts.gameplay.entities.beings.monsters.Monster1
import silmarengine.contexts.gameplay.entities.beings.monsters.extensions.creation.generateMonster
import silmarengine.contexts.gameplay.entities.beings.monsters.types.MonsterType
import silmarengine.contexts.gameplay.entities.beings.player.Player
import silmarengine.contexts.gameplay.areas.extensions.visibility.canSeeExt
import silmarengine.contexts.gameplay.areas.geometry.PixelDistance
import silmarengine.contexts.gameplay.tiles.tileWidth

abstract class Generator : Monster1() {
    /**
     * Returns the monster type generated by this generator.
     */
    protected abstract val generateType: MonsterType

    /**
     * Returns per how many game turns this generator generates a monster.
     */
    protected abstract val interval: Int

    override fun usePreMovementPower(player: Player): Boolean {
        // if a player was not given, or this generator cannot see the given player
        if (!area.canSeeExt(location, player.location).canSee) {
            // if a passible path to the player of at most a certain distance cannot be found
            if (!area.adjacencyGraph!!.getPathExists(location, player.location,
                    playerProximityForGeneration, true).pathExists) {
                // de-activate this generator, so it doesn't keep generating monsters
                // while the player is away
                isActivated = false
                return true
            }
        }

        // potentially generate a new monster
        return generateMonster(area, location, generateType, interval)
    }

    companion object {
        /**
         * The maximum distance this generator can be from a player and still be
         * generating monsters.
         */
        protected val playerProximityForGeneration = PixelDistance(25 * tileWidth)
    }
}

class Vortex : Generator() {
    override val generateType: MonsterType
        get() = SilmarMonsterTypes.ghost
    override val interval: Int get() = 2
}

class Bones : Generator() {
    override val generateType: MonsterType
        get() = SilmarMonsterTypes.moldySkeleton
    override val interval: Int get() = 3
}

class Grave : Generator() {
    override val generateType: MonsterType
        get() = SilmarMonsterTypes.giantZombie
    override val interval: Int get() = 5
}

